#ifndef MILSTRUC_GOALHEADERS_H
#define MILSTRUC_GOALHEADERS_H
#include "GoalGeneratorBase.h"
#include "GoalTypes.h"

class MilitaryStructureManagerAgent;

// worker training goal
class Military_BuildBarracksGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildBarracksGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
				// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
		int temporalFactor;
		// implementation-specific stuff, if needed
		

};





class Military_BuildAcademyGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildAcademyGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
			int temporalFactor;
		// implementation-specific stuff, if needed
		

};





class Military_BuildStarportGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildStarportGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
			int temporalFactor;
		// implementation-specific stuff, if needed
		

};



class Military_BuildFactoryGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildFactoryGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
			int temporalFactor;
		// implementation-specific stuff, if needed
		

};





class Military_BuildArmoryGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildArmoryGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
			int temporalFactor;
		// implementation-specific stuff, if needed
		

};



class Military_BuildEngineeringBayGoalGenerator : public GoalGeneratorBase {
	public:
		Military_BuildEngineeringBayGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		MilitaryStructureManagerAgent* parent;
		GoalDescriptor* goal;
			int temporalFactor;
		// implementation-specific stuff, if needed
		

};




class Military_BuildScienceFacilityGoalGenerator : public GoalGeneratorBase {
public:
	Military_BuildScienceFacilityGoalGenerator(AgentPool* a, MilitaryStructureManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();
	// what


private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	MilitaryStructureManagerAgent* parent;
	GoalDescriptor* goal;
		int temporalFactor;
	// implementation-specific stuff, if needed


};

#endif