#ifndef BHEADERS_GOALHEADERS_H
#define BHEADERS_GOALHEADERS_H
#include "GoalGeneratorBase.h"
#include "GoalTypes.h"

class ResearchManagerAgent;
class InformationManagerAgent;

// worker training goal
class Research_CommandCentreUpgradeGoalGenerator : public GoalGeneratorBase {
	public:
		Research_CommandCentreUpgradeGoalGenerator(AgentPool* a, ResearchManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		ResearchManagerAgent* parent;
		GoalDescriptor* goal;
		int temporalFactor;
		// implementation-specific stuff, if needed
		

};





// worker training goal
class Research_StarportUpgradeGoalGenerator : public GoalGeneratorBase {
	public:
		Research_StarportUpgradeGoalGenerator(AgentPool* a, ResearchManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		ResearchManagerAgent* parent;
		GoalDescriptor* goal;
		// implementation-specific stuff, if needed
		

};





// worker training goal
class Research_FactoryUpgradeGoalGenerator : public GoalGeneratorBase {
	public:
		Research_FactoryUpgradeGoalGenerator(AgentPool* a, ResearchManagerAgent* parent);

		// generic stuff
		virtual void inhibit();
		virtual bool instantiateGoal();
		virtual void updateDrives();
		virtual void initialize();
		virtual int getdrive();
		virtual int getthresh();
		// what
		
	
	private:

		// generic stuff
		bool inhibited;
		AgentPool* agentPool;
		int drive;
		int thresh;
		int priority;
		ResearchManagerAgent* parent;
		GoalDescriptor* goal;
		int temporalFactor;
		// implementation-specific stuff, if needed
		

};



// worker training goal
class Research_ScienceFacilityUpgradeGoalGenerator : public GoalGeneratorBase {
public:
	Research_ScienceFacilityUpgradeGoalGenerator(AgentPool* a, ResearchManagerAgent* parent);

	// generic stuff
	virtual void inhibit();
	virtual bool instantiateGoal();
	virtual void updateDrives();
	virtual void initialize();
	virtual int getdrive();
	virtual int getthresh();
	// what


private:

	// generic stuff
	bool inhibited;
	AgentPool* agentPool;
	int drive;
	int thresh;
	int priority;
	ResearchManagerAgent* parent;
	GoalDescriptor* goal;
	// implementation-specific stuff, if needed


};







#endif